codeforce 3B. Lorry(贪心)

题目:http://codeforces.com/problemset/problem/3/B

大意是,给定N和V,在给出N个vehicle的类型号(1或2)和各自的载重量,求在不超过V的情况下最大的载重值及其分配方案。

这应该不用01背包,如果用背包Vei数组开不了那么大。那怎么破?因为存在物品空间占用1这一特殊条件,所以只要ka够用就能把V填满,这里可以用贪心做。先把ka和ca各自的数据按照"性价比"(也就是载重量)从大到小排序(V=1的ka在这里扮演着修补的角色,所以我们先装ca再装ka,即先多占用空间)。当ka装完或者空间不能继续装下去的时候即停下来,然后装入ca。先把空间使用完再优化,如果ca的空间利用值高则用它来换掉已装空间值低的ka(用尽可能高的换取尽可能低的,让整个空间的利用率快速增长)。按照这个贪心的思路最终能得到结果。(参考了别人的pair代码,我也学习着用用~)

#include 
#include
#include
#include
using namespace std;
const int maxn=1e5+10;
int n,v;
bool cmp(pair a,pair b){
    return a.second>b.second;
}
int main()
{
    //freopen("cin.txt","r",stdin);
    while(cin>>n>>v){
        vector > ka,ca,ans;
        int i,j;
        int a,b,lasta,firstb,val=0;
        for(i=0;i1&&lasta0&&firstb=0){
            if(ka[j].second+ka[j+1].second>ans[i].second){
                ans.erase(ans.begin()+i);
                ans.push_back(ka[j]);
                ans.push_back(ka[j+1]);
                j++;
                i--;
            }
            j++;
        }
        if(j==ka.size()-1&&i>=0)
            if(ka[j].second>ans[i].second){
                ans.erase(ans.begin()+i);
                ans.push_back(ka[j]);
            }
        for(j=0;j

题目中有这样一句话:"In the second line print a string consisting of the numbers of the vehicles that make the optimal set." 开始我一直认为是输出type:0或1,但是一直死在test 2,后来看了别人的代码才知道是编号1,2,3,4,……

你可能感兴趣的:(algorithm_贪心)